<?php

class Exporta
{

	public function exportFirebirdToCsv( $strQuery, $Ds_Arquivo_Destino = 'export.csv' )
	{
		
        $Ds_Separador_Linha = "\n";
        $Ds_Separador_Coluna = ";";
        $Ds_Caracter_Encapsular = '"';
        $Ds_Caracter_Escape = "\\";


        // Recupera os dados do servidor
        $Ds_Retorno = ibase_query( $strQuery );
        $Nr_Colunas = ibase_num_fields( $Ds_Retorno );


        $Ds_Linha_CSV = '';

        for ( $i = 0; $i < $Nr_Colunas; $i++ )
        {
            $arrColuna = ibase_field_info( $Ds_Retorno, $i );
            $Ds_Linha_CSV .= $arrColuna['name'] . $Ds_Separador_Coluna;
        } // end for

        $Ds_Saida = trim( substr( $Ds_Linha_CSV, 0, -1 ) );
        $Ds_Saida .= $Ds_Separador_Linha;

        // Format the data
        while ( $Ds_Linha_Banco = ibase_fetch_row( $Ds_Retorno ) )
        {
            $Ds_Linha_CSV = '';
            for ( $j = 0; $j < $Nr_Colunas; $j++ )
            {
                if ( $Ds_Linha_Banco[$j] == '0' || $Ds_Linha_Banco[$j] != '' )
                {

                    if ( $Ds_Caracter_Encapsular == '' )
                    {
                        $Ds_Linha_CSV .= $Ds_Linha_Banco[$j];
                    }
                    else
                    {
                        $Ds_Linha_CSV .= $Ds_Caracter_Encapsular . str_replace( $Ds_Caracter_Encapsular, $Ds_Caracter_Escape . $Ds_Caracter_Encapsular, $Ds_Linha_Banco[$j] ) . $Ds_Caracter_Encapsular;
                    }
                }
                else
                {
                    $Ds_Linha_CSV .= '';
                }

                if ( $j < $Nr_Colunas - 1 )
                {
                    $Ds_Linha_CSV .= $Ds_Separador_Coluna;
                }
            } // end for

            $Ds_Saida .= $Ds_Linha_CSV;
            $Ds_Saida .= $Ds_Separador_Linha;
        } // end while
        
        
		// Grava o arquivo fsico
		if ( !is_dir( dirname( $Ds_Arquivo_Destino ) ) )
		{
			mkdir( dirname( $Ds_Arquivo_Destino ), 0755, true );
		}

		$criarArquivo = (!is_file( $Ds_Arquivo_Destino ) );
		$objTxt = fopen( $Ds_Arquivo_Destino, "w" );
		if ( $criarArquivo)
		{
			//UTF-8
			fwrite( $objTxt, pack( "CCC", 0xef, 0xbb, 0xbf ) );
		}
		
		fwrite( $objTxt, $Ds_Saida );
		fclose( $objTxt );
		

	}
	
}


?>